package edu.travel.tenant.web;

import com.baomidou.mybatisplus.extension.service.IService;
import edu.travel.resp.BaseResponse;
import edu.travel.resp.PageResponse;
import edu.travel.tenant.entity.EduTenant;
import edu.travel.tenant.entity.SysRole;
import edu.travel.tenant.service.ITenantService;
import edu.travel.tenant.vo.EduTenantVo;
import edu.travel.web.BaseController;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.access.prepost.PreAuthorize;
import org.springframework.security.core.context.SecurityContextHolder;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Set;

@RestController
@RequestMapping("/tenant")
public class TenantController  extends BaseController<EduTenant> {
    @Autowired
    private ITenantService tenantService;

    @GetMapping("/getTenant")
    public BaseResponse getTenant() {
        EduTenant principal = (EduTenant)SecurityContextHolder.getContext().getAuthentication().getPrincipal();
        EduTenant list = tenantService.getTenantByID(principal.getTenantPhone());
        return PageResponse.out(200,"success",list);
    }

    @PostMapping("/addTenant")
//    @PreAuthorize("hasRole('超级管理员')")
    public BaseResponse addTenant(EduTenant tenant) {
        tenantService.addTenant(tenant);
        return PageResponse.out(200,"success",tenant);
    }

    @PostMapping("/deleteTenantByIds")
//    @PreAuthorize("hasRole('超级管理员')")
    public BaseResponse deleteTenant(Set<Long> ids) {
        tenantService.deleteByIds(ids);
        return PageResponse.out(200,"success",ids);
    }

    @PostMapping("/updateTenantById")
//    @PreAuthorize("hasRole('超级管理员')")
    public BaseResponse updateTenant(EduTenant tenant) {
        tenantService.updateTenant(tenant);
        return PageResponse.out(200,"success",tenant);
    }

    @GetMapping("/getTenantById")
    public BaseResponse getTenantById(Long id) {
        EduTenant tenant = tenantService.getTenantById(id);
        return PageResponse.out(200,"success",tenant);
    }

//    @GetMapping("/getMenuList")
//    public BaseResponse getMenuList() {
//        List<SysRole> menuList = tenantService.getMenuList();
//        return PageResponse.out(200,"success",menuList);
//    }
}
